#!/usr/bin/perl

$f_input=$ARGV[0];
$f_output=$ARGV[1];


push(@INC,"/usr/lib/perl5");
require("flush.pl");


&printflush(STDOUT, "\nI create disassembled file ...\n I try to use objdump -dTx\n I.E. all sections with data, all variable data extraction \n Starting NOW........");




#############################################################################
###############     Beginning                  ##############################
#############################################################################




$return=system("objdump -dTx --prefix-addresses ".$f_input." > ".$f_output."2");

#############################################################################
###############     Help Message               ##############################
#############################################################################

if ($return!=0){
  print "\nERROR : Check OBJDUMP $return";
  print "\nUsage: perl disassem_versionA_.pl   exe_file(ELF/TYPE)   S-CRACkED_file";
  print "\nBe sure to get objdump in your path. Check also file
  permissions\n"; exit(1);
 }






&printflush(STDOUT, "\nI read the strings of the elf...\n");
open(INPUT, "<".$f_output."2");


#############################################################################
###############     First Section...........   ##############################
###############       .RODATA                  ##############################
#############################################################################



$_=<INPUT>;
while (!/.rodata/){
  $_=<INPUT>;
}




($rubbish, $rest)=split(/.rodata/,$_,2);
($rubbish, $rest)=split(/0/,$rest,2);
@numbers=split(/  /,$rest,5);
$size=hex($numbers[0]);
$starting_address=hex($numbers[1]);
$end_address=$starting_address+$size;
$offset=hex($numbers[3]);





open(CODICE, "<".$f_input);
seek(CODICE,$offset,0);
read(CODICE,$catena,$size);
close(CODICE);


#############################################################################
###############     First Section...........   ##############################
###############           END                  ##############################
#############################################################################








#############################################################################
###############     2-nd  Section...........   ##############################
###############       .Tabella Simboli         ##############################
#############################################################################



SEARCH: while (<INPUT>){
  last SEARCH if (/SYMBOL TABLE/);
}
if (/SYMBOL TABLE/){ 
  &printflush(STDOUT, "\nI go to process the symbol-table ...\n");
  $_=<INPUT>;
  while (!/^\n/){
   @st_element=split(/ /, $_);
   $_=$st_element[$#st_element];
   chop;
   $symbol_table{$st_element[0]}=$_;
   $_=<INPUT>;
  }
}
else {
  seek(INPUT,0,0);

}







#############################################################################
###############     3-th  Section...........   ##############################
###############       .Text                    ##############################
#############################################################################



while (!/\.text/){
  $_=<INPUT>;
}





#############################################################################
#############################################################################
&printflush(STDOUT,  "\nI now process jumps and calls ...\n");




while (<INPUT>){
  $_=~ s/0x//g;
  $_=~ s/<.*?>//g;
  $_=~s/  / /g;
  if (/j/){
    ($direction,$inst,$destination)=split(/ /,$_,3);
    $destination=~s/ //g;
    chomp($destination);
    $salto{$destination}.=($direction." \; ");
  }
  elsif (/call/){
    ($direction,$inst,$destination)=split(/ /,$_,3);
    $destination=~s/ //g;
    chomp($destination);
    $call{$destination}.=($direction." \; ");
  }
}

seek(INPUT,0,0);



&printflush(STDOUT, "\nJust writing references ...\n");



#############################################################################
#############################################################################
open(OUTPUT, ">".$f_output) || die print "\nError opening  file for writing!!!\n";
print OUTPUT "FILE REFERENCED\n\n";
#############################################################################
#############################################################################

while (!/Disassembly of section .text:/){
 $_=<INPUT>;
 print OUTPUT;
}

$char=".";
$counter=0;


while(<INPUT>){
 $counter++;

 if ( ($counter % 400)==0){
   printflush(STDOUT,$char);
   if ( ($counter % 4000)==0){
     printflush(STDOUT,"\r");
     if ($char eq "."){ $char=" ";}
     else { $char=".";}
   }  
 }

 $copia=$_;
 $_=~s/0x//g;
 $_=~s/<.*?>//ge;
 $_=~s/  / /g;
 ($direction, $inst, $destination)=split(/ /,$_,3);
 if ( defined( $symbol_table{$direction} )){
   print OUTPUT "\n";
   print OUTPUT "---- Function : ".$symbol_table{$direction}." ----\n";
 }
 if (/call/){
   $destination=~s/ //g;
   chomp($destination);
   if ( defined( $symbol_table{$destination} )){
     print OUTPUT "\n";
     print OUTPUT "Reference to function : ".$symbol_table{$destination}."\n\n";
   }
 }  
 if ( defined( $salto{$direction} )){
   print OUTPUT "\n";
   print OUTPUT "Referenced from jump at ".$salto{$direction}."\n\n";
 }
 if ( defined( $call{$direction} )){
   print OUTPUT "\n";
   print OUTPUT "Referenced from call at ".$call{$direction}."\n\n";
 }
 if (/\$/){
        ($instruction, $operand)=split(/\$/,$_,2);
        if (!/push/){
          ($operand, $rest)=split(/\,/,$operand,2);
        }
        chomp($operand);
        $offset=hex($operand);
        if ( ($offset <= $end_address) && ($offset >= $starting_address )
        ){
          $auxiliar=substr($catena, $offset-$starting_address);
          $length=index($auxiliar, pack("x") );
          $auxiliar=substr($auxiliar, 0, $length);       
          $auxiliar=~s/\n//g;
          print OUTPUT "\n";
          print OUTPUT "Possible reference to string:";
          print OUTPUT "\n\"$auxiliar\"\n\n"
        }       
  }
 print OUTPUT $copia;
}

printflush(STDOUT, "\nResult are in file : $f_output");


close(INPUT);
close(OUTPUT);
print "\n";
system("rm ".$f_output."2");

